<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/

require("../inc/stop_cache.php");
$nAdminOnlyPg = 0;
require("../inc/secure_page.php");
// connect to mysql
require("../../inc/dbconnect.php");
require("../../inc/config.php");
require("../inc/langutil.php");

// config
$nRefreshCall = "refreshParentsCompAdd();";

// Get passed-in vars
$nRecID = $_GET["id"];
if(!$nRecID){ $nRecID = $_POST["id"]; }

$nCompPath = "../../comp/";

// Get all new components and import them into the database
nImportNewComps();

// AJAX Specific vars
$nPassThru = "";
$nDivToUpdate = "editModal";
$nPageInDiv = "dialog/component_add.php";

// Get additional data
if($nRecID){
	$nSQL = "SELECT nType,nTitle FROM nPage WHERE nID=$nRecID LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nType = $Row["nType"];
		$nTitle = $Row["nTitle"];
	}
}
?>

<div id="<?=$nDivToUpdate;?>">
<?php
include("../inc/form_class.php");

$nFormName = "FormCompAdd";
$nForm1 = new Form();
$nForm1->Name = $nFormName;
$nForm1->Action = $_SERVER['PHP_SELF'];
$nForm1->CancelText = "Cancel";
$nForm1->CancelRedirect = "Modalbox.hide();return false;";
$nForm1->CancelRedirectIsJS = true;
$nForm1->SubmitText = "Add Component";
$nForm1->AddToDBTable = "xComponentPage";

$nForm1->DBLink = $Link;
$nForm1->nUseADODB = false;
// AJAX settings
$nForm1->SubmitIsJS = true;
$nForm1->SubmitToJS = "return submitForm('$nDivToUpdate','$nPageInDiv$nPassThru','$nFormName');return false;";

// Create groups
$nFormGroup1 = new FormGroup();

// Create fields
$nFormField = new FormField("hidden","nID");
$nFormField->Value = nGetNextCompNum();
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("hidden","nPageID");
$nFormField->Value = $nRecID;
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("hidden","nColumnID");
$nFormField->Value = "1"; // default
$nFormGroup1->AddField($nFormField);

$nFormField = new FormField("select","nComponentID","Component Type:");
$nFormField->onBlur = "nShowCompGuide('comp_'+this.value);";
$nFormField->DataARRAY = nGetComponentARRAY();
if($nRecID){
	$nFormField->SelectedARRAY = array("$nComponentID" => "selected");
} else {
	$nFormField->SelectedARRAY = array("0" => "selected"); // default
}
$nFormGroup1->AddField($nFormField);

// Finalize and display form
$nForm1->AddGroup($nFormGroup1);
$nFormToDisplay = $nForm1->GetForm();

// AJAX redirect if form submitted w/o error, otherwise display form (again, if necessary)
if($nForm1->HasProcessed){
	// Go directly to Edit Component Content screen
	echo "<script>$nRefreshCall</script>";
	echo "<script>Modalbox.show('dialog/component_edit.php?id=".$_POST["nID"]."',{title: 'Edit Component', width: 800, overlayClose:false});</script>";
	exit();
} else {
	echo $nFormToDisplay;
	echo "<script>Modalbox.resizeToContent();</script>";
}
?>
	
	<BR>
	<div id="compBox" style="border:1px solid #EEE;padding:10px;">
		<?=nGetCompGuide();?>
	</div>
<script>
nShowCompGuide = function(nCompToShow){
	var compARRAY = $('compBox').childElements();
	compARRAY.each(function(node){
		node.hide();
	});
	eval("$(nCompToShow).show();");
	Modalbox.resizeToContent();
}
refreshParentsCompAdd = function(){
	try{ refreshPageComps(); } catch(e){ }
}
</script>
	
</div>
<?php
// to capture calls and prevent errors from included comp, but not needed to run now
function addField($nFldID="",$nTitle="",$nCaption="",$nDefVal=""){
	return;
}

function nImportNewComps(){
	global $DBName,$Link;
	global $nCompPath,$nDefaultLang;
	// Get all files in Components directory
	$dir_handle = @opendir($nCompPath) or die("Unable to open Component path: $nCompPath");
	while ($file = readdir($dir_handle)) {
		if($file == "." || $file == ".." || $file == "index.php" )
			continue;
		if(!is_dir("$nCompPath$file")){
			// reset imported vars
			$nName = ""; $nDescription = ""; $nPageTypeLimit = ""; $nTemplateFile = "";
			$nFileName="$file";
			$nFilePath="$nCompPath$file";
			if(file_exists("$nFilePath")){
				// Pull in component settings file
				// include($nFilePath);
				$nConnFile = fopen($nFilePath,"r");
				if($nConnFile){
					$nFileCode = fread($nConnFile,filesize($nFilePath));
					fclose($nConnFile);
				} else { return 0; }
				$nFileCode = str_replace("\r\n","\n",$nFileCode);
				$nFileCodeARRAY = explode("\n",$nFileCode);
				if(strpos($nFileCodeARRAY[2],"nName")){ eval($nFileCodeARRAY[2]); }
				if(strpos($nFileCodeARRAY[3],"nDescription")){ eval($nFileCodeARRAY[3]); }
				if(strpos($nFileCodeARRAY[4],"nPageTypeLimit")){ eval($nFileCodeARRAY[4]); }
				if(strpos($nFileCodeARRAY[5],"nTemplateFile")){ eval($nFileCodeARRAY[5]); }
				if($nName){
					$nCompID = nGetCompIDFromName($nName);
					//print "id exists for $nName: $nCompID<BR>";
					if($nTemplateFile && !$nCompID){ // if comp doesn't already exist in DB (no ID exists), add it
						$nName = nTruncateString(trim($nName),50);
						$nDescription = addslashes(nTruncateString(trim($nDescription),255));
						$nPageTypeLimit = addslashes(nTruncateString(trim($nPageTypeLimit),50));
						$nTemplateFile = nTruncateString(trim($nTemplateFile),255);
						$nTemplateFilePath="$nCompPath$nTemplateFile";
						$nLangPath = "$nDefaultLang/";
						$nTemplateOverridePath = "$nCompPath$nLangPath$nTemplateFile";
						//print "template file ($nTemplateFilePath) exists? ".file_exists("$nTemplateFilePath")."<BR>";
						//print "template override file ($nTemplateOverridePath) exists? ".file_exists("$nTemplateOverridePath")."<BR>";
						// Add plugin to database un-activated if all tests passed
						if($nName && (file_exists("$nTemplateFilePath") || file_exists("$nTemplateOverridePath"))){
							//print "saving to db<BR>";
							$Query = "INSERT INTO nComponent VALUES ('0','$nName','$nDescription','1','$nPageTypeLimit','$nFileName')";
							mysql_select_db($DBName);
							mysql_query($Query, $Link);
						}
					}
				}
			}
		}
	}
	closedir($dir_handle);
	return $nTable;
}

function nTruncateString($nStr,$nMax){
  if(strlen($nStr)>$nMax) {
    $leave = $max - strlen($rep);
    return substr($nStr,0,$nMax);
  }
  return $nStr;
}
function nGetCompIDFromName($nCompName){
	global $DBName, $Link;
	if(!$nCompName){ return; }
	$Query = "SELECT nID FROM nComponent WHERE nName='$nCompName'";
	$Result = mysql_db_query ($DBName,$Query,$Link);
	while ($Row = mysql_fetch_array($Result)) {
		$nID = $Row[nID];
	}
	return $nID;
}

function nGetNextCompNum(){
	global $DBName,$Link;
	$nSQL = "SELECT Max(nID) AS nID FROM xComponentPage";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"] + 1;
	}
	return $nID;
}

function nGetNextContentNum(){
	global $DBName,$Link;
	$nSQL = "SELECT Max(nID) AS nID FROM nContent";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"] + 1;
	}
	return $nID;
}

function nGetComponentARRAY(){
	global $DBName,$Link,$nType;
	global $nRecID;
	$nDataARRAY = array();
	$nSQL = "SELECT * FROM nComponent WHERE nActive=1 ORDER BY nName";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nName = $Row["nName"];
		$nTypeLimit = $Row["nTypeLimit"];
		if($nTypeLimit){
			if($nType==$nTypeLimit){ $nDataARRAY["$nID"] = "$nName"; }
		} else {
			$nDataARRAY["$nID"] = "$nName";
		}
	}
	return $nDataARRAY;
}

function nGetCompGuide(){
	global $DBName,$Link;
	$nFirstRow = true;
	$nSQL = "SELECT * FROM nComponent ORDER BY nName";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nID = $Row["nID"];
		$nName = $Row["nName"];
		$nDesc = $Row["nDesc"];
		if($nFirstRow){
			$nTable.="<div id=\"comp_$nID\"><strong>$nName</strong><BR>$nDesc</div>";
			$nFirstRow = false;
		} else {
			$nTable.="<div id=\"comp_$nID\" style=\"display:none;\"><strong>$nName</strong><BR>$nDesc</div>";
		}
	}
	return $nTable;
}
?>
<? require("../../inc/db_close.php"); ?>
