<?php
/*
 * This file is part of Web Pro Manager.
 * 
 * Web Pro Manager is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Web Pro Manager is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Web Pro Manager.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author The Web Pro Miami, Inc. <info@thewebpro.com>
 * @copyright The Web Pro Miami, Inc. <info@thewebpro.com>, http://www.thewebpro.com/
 * @license http://www.gnu.org/licenses/gpl.html GNU GPL
 * @package WebProManager
*/

// Next line to start calc of page load time
$nPLTStart = microtime(); $nPLTStartARRAY = explode(" ", $nPLTStart); $nPLTStart = $nPLTStartARRAY[1] + $nPLTStartARRAY[0];
require("inc/stop_cache.php");
$nAdminOnlyPg = 0;
require("inc/secure_page.php");
// connect to mysql
require("../inc/dbconnect.php");
require("../inc/config.php");
include("inc/imgedit.php");

// Get passed-in vars
$nRecID = $_GET["id"];

// if limited user, get page access to apply limitations
// if trying to access a page w/o authorization, kick them out
if(!$nAdminAccess){ $nPageIDAccessARRAY = nGetPageIDAccessARRAY($ValidUser); }
if(!$nAdminAccess && !in_array($nRecID,$nPageIDAccessARRAY)){
	header ("Location: index.php?msg=4");
	exit;
}
$nPagePath = nGetPagePath($nRecID);
$nPageName = nGetPageName($nRecID);
$nSectionID = nGetSectionID($nRecID);
$nPageType = nGetPageType($nRecID);
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>Control Panel :: <?=$nSiteName;?></title>
<link rel="stylesheet" type="text/css" href="css/meta-admin.css" />
<link rel="stylesheet" type="text/css" href="css/blue-theme.css" />
<!--[if lte IE 6]><link media="screen" rel="stylesheet" type="text/css" href="css/ie.css" /><![endif]-->
<link href="css/modalbox.css" rel="stylesheet" type="text/css" media="screen">
<link href="css/form.css" rel="stylesheet" type="text/css">
<link href="css/drag_drop.css" rel="stylesheet" type="text/css">
<script type="text/javascript" src="js/css.js"></script>
<script type="text/javascript" src="js/behaviour.js"></script>
<script type="text/javascript" src="js/refresh.js"></script>
<script src="js/utility.js" type="text/javascript"></script>
<script src="js/prototype.js" type="text/javascript"></script>
<script src="js/scriptaculous.js" type="text/javascript"></script>
<script src="js/proto_processor.js" type="text/javascript"></script>
<script src="js/modalbox.js" type="text/javascript"></script>
<script type="text/javascript" src="rte/fckeditor.js"></script>
<script>
document.observe('dom:loaded', function() {
	// load page content modules
	loadContent('ajaxPageEdit','arrange/page_components.php?id=<?=$nRecID;?>');
});
</script>
</head>

<body onLoad="MM_preloadImages('img/load.gif');">

<div id="wrapper">
	
	<? require("inc/header.php"); ?>

	<div id="content">
		<div id="content_bottom">
			<div class="inner">
				<div id="info">
					<div class="section">
					
						<div class="title_wrapper">
							<h2>Edit Page: <?=$nPageName;?></h2>
							<div id="product_list_menu">
								<a href="dialog/component_add.php?id=<?=$nRecID;?>" title="Add New Component" onClick="Modalbox.show(this.href,{title: this.title, width: 500, overlayClose:false}); return false;" class="update"><span><span><em>Add New Component</em><strong></strong></span></span></a>
							</div>
						</div>
						<div id="ajaxPageEdit"></div><BR>
				
					</div>
					<BR><BR><BR><BR>
				</div>
				<div id="sidebar" style="padding-top:0px;">
					
					<!--[if !IE]>start sidebar module<![endif]-->
					<div class="sidebar_module">
						<div class="title_wrapper">
							<h3>Tools</h3>
						</div>
						<div id="secondary_menu">
							<ul>
								<li><a href="dialog/page_add.php?id=<?=$nRecID;?>" title="Edit Page Settings" onClick="Modalbox.show(this.href,{title: this.title, width: 500, overlayClose:false}); return false;">Edit Page Settings</a></li>
								<li><a href="<?=$nPagePath;?>" target="_blank">View this page on website</a><BR><span class="caption">(opens in new window)</span></li>
								<?if($nPageType=="Content"){?>
								<li><a href="dialog/page_duplicate.php?id=<?=$nRecID;?>" title="Duplicate Page" onClick="Modalbox.show(this.href,{title: this.title, width: 500, overlayClose:false}); return false;">Duplicate this page</a></li>
								<?}?>
							</ul>
						</div><BR><BR>
						
						<div class="title_wrapper">
							<h3>Related Pages</h3>
						</div>
						<div id="secondary_menu" class="cleanMenu" style="padding:10px 0;">
							<?=nGetPages($nSectionID);?>
						</div>
					</div>
					<!--[if !IE]>end sidebar module<![endif]-->
					
				</div>
			</div>
		</div>
	</div>
	
</div>
	
	<? require("inc/footer.php"); ?>
	
<div id="status" style="display:none;"><table><tr><td class="padRight"><img src="img/load.gif" alt="" width="16" height="16" border="0"></td><td><div align="center">Loading...<BR>Please wait<BR></div></td></tr></table></div>
	
</body>
</html>
<?
function nGetPagePath($nPageID){
	global $DBName,$Link;
	if(!$nPageID){ return; }
	$nSQL = "SELECT nType,nTitle,nNavTitle FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nType = $Row["nType"];
		$nTitle = $Row["nTitle"];
		$nNavTitle = $Row["nNavTitle"];
	}
	switch($nType){
		case "Homepage": $nPagePath = "index.php"; break;
		case "Content":
			$nPageNameForPath = nPrepareNameForPath($nNavTitle); // for mod-rewrite
			$nPagePath = $nPageID."/".$nPageNameForPath.".html"; // for mod-rewrite
			$nPagePath = $nFullSitePath.$nPagePath;
			//$nPagePath = $nFullSitePath."content.php?id=$nPageID";
			break;
		case "Search": $nPagePath = "search.php"; break;
		case "Link": $nPagePath = $nTitle; break;
	}
	if($nPagePath){ $nPagePath = "../$nPagePath"; }
	return $nPagePath;
}

function nPrepareNameForPath($nName){
	if(!$nName){ return; }
	$nName = str_replace(" ","-",$nName);
	$nRemoveARRAY = array(".",",",";",":","'","!","$","#","?","&","*","%","@","(",")","/","\\","<",">");
	$nName = str_replace($nRemoveARRAY,"",$nName);
	$nName = str_replace("--","-",$nName);
	return $nName;
}

function nGetPageIDAccessARRAY($ValidUser){
	global $DBName,$Link;
	if(!$ValidUser){ return; }
	// Get user ID
	$nSQL = "SELECT nID FROM nEditor WHERE nUser='$ValidUser' LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nEditorID = $Row["nID"];
	}
	$nDataARRAY = array();
	$nSQL = "SELECT nPageID FROM xEditorPage WHERE nEditorID=$nEditorID";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nPageID = $Row["nPageID"];
		$nDataARRAY[] = $nPageID;
	}
	return $nDataARRAY;
}

function nGetPageName($nPageID){
	global $DBName,$Link;
	if(!$nPageID){ return; }
	$nSQL = "SELECT nNavTitle FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nNavTitle = $Row["nNavTitle"];
	}
	return $nNavTitle;
}

function nGetSectionID($nPageID){
	global $DBName,$Link;
	if(!$nPageID){ return; }
	$nSQL = "SELECT nSectionID FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nSectionID = $Row["nSectionID"];
	}
	return $nSectionID;
}

function nGetPages($nSectionID){
	global $DBName,$Link,$nAdminAccess,$nPageIDAccessARRAY,$_SERVER,$nFullSitePath;
	if($nSectionID===""){ return ""; }
	$nBrowserType = $_SERVER["HTTP_USER_AGENT"];
	$nIsIE = strpos($nBrowserType," MSIE ");
	$nCurrRec = 0;
	$nSQL = "SELECT * FROM nPage WHERE nSectionID=$nSectionID ORDER BY nOrderID";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	while($Row = mysql_fetch_array($Result)){
		$nCurrRec++;
		$nID = $Row["nID"];
		$nNavTitle = $Row["nNavTitle"];
		$nTitle = $Row["nTitle"];
		$nBGColor = $Row["nBGColor"];
		$nBaseColor = $Row["nBaseColor"];
		$nBGImgID = $Row["nBGImgID"];
		$nType = $Row["nType"];
		switch($nType){
			case "Homepage": $nAddIcon = "<div id=\"editMini\"><img src=\"img/icon_home.png\" width=\"26\" height=\"26\" border=\"0\"></div>"; break;
			case "Search": $nAddIcon = "<div id=\"editMini\"><img src=\"img/icon_search.png\" width=\"26\" height=\"26\" border=\"0\"></div>"; break;
			case "Link": $nAddIcon = "<div id=\"editMini\"><img src=\"img/icon_link.png\" width=\"26\" height=\"26\" border=\"0\"></div>"; break;
			default: $nAddIcon = ""; break;
		}
		$nHoverCODE = "";
		// Generate ICON
		// NOTE: if naming conventions change here, it's a good idea to delete all files in 'nIcnFilePath' to save space
		$nIcnBGClr = $nBGColor;
		$nIcnTxt = $nNavTitle;
		$nIcnFileName = nSanitizeFilename("icn_".$nIcnBGClr."_".$nIcnTxt.".png");
		$nIcnFilePath = "../usr/system/icons/mini/$nIcnFileName";
		$nIcnFinalPath = "usr/system/icons/mini/$nIcnFileName";
		if(!file_exists($nIcnFilePath)){
			nImg_MakeMiniIcon($nIcnFilePath,$nIcnBGClr,$nIcnTxt);
		}
		if(!file_exists($nIcnFilePath)){ print "<strong style=\"color:#CC0000;\">Image error: could not create icon at '$nIcnFilePath'. Please make sure that this folder is writable.</strong><BR>"; $nIcnFilePath=""; }
		if($nIcnFilePath){
			$nImgTagARRAY = getimagesize($nIcnFilePath); $nImgTagWH = $nImgTagARRAY[3];
			$nIcnTag = "<img src=\"$nFullSitePath$nIcnFinalPath\" alt=\"\" $nImgTagWH border=\"0\">";
		}
		// END Generate Icon
		if(!$nAdminAccess && in_array($nID,$nPageIDAccessARRAY)){ $nHasPageAccess = 1; } else { $nHasPageAccess = 0; }
		if($nAdminAccess){ $nHasPageAccess = 1; }
		if($nHasPageAccess){
			if($nType=="Link"){
				$nIcnTag = "<a href=\"dialog/page_add.php?id=$nID\" title=\"Edit Page Settings\" onClick=\"Modalbox.show(this.href,{title: this.title, width: 500, overlayClose:false}); return false;\">$nIcnTag</a>";
			} else {
				$nIcnTag = "<a href=\"page_edit.php?id=$nID\" title=\"$nIcnTxt\">$nIcnTag</a>";
			}
			$nTable.= <<<CODE
				<div id="icon_$nID" class="icon" $nHoverCODE>$nIcnTag<div id="editStamps" style="width:30px;">$nAddIcon</div></div>
CODE;
		}
	}
	return $nTable;
}
function nGetPageType($nPageID){
	global $DBName,$Link;
	if(!$nPageID){ return; }
	$nSQL = "SELECT nType FROM nPage WHERE nID=$nPageID LIMIT 1";
	$Result = mysql_db_query ($DBName,$nSQL,$Link);
	if($Row = mysql_fetch_array($Result)){
		$nType = $Row["nType"];
	}
	return $nType;
}
?>
<? require("../inc/db_close.php"); ?>

